import 'package:pigeon/pigeon.dart';

import 'aidlab.dart';
import 'empty_event.dart';

class ConnectRequest {
  String address;
  Int32List signals;
}

class AidlabDetectedEvent {
  String address;
  int rssi;
}

class ScanFailedEvent {
  int errorCode;
}

@HostApi()
abstract class PlatformAidlabSdk {
  void scanForDevices();
  void stopDeviceScan();
  void connect(ConnectRequest request);
}

@FlutterApi()
abstract class PlatformAidlabSdkDelegate {
  void onBluetoothStarted(EmptyEvent voidEvent);
  void onDeviceScanStarted(EmptyEvent voidEvent);
  void onDeviceScanStopped(EmptyEvent voidEvent);
  void onScanFailed(ScanFailedEvent event);
  void onAidlabDetected(AidlabDetectedEvent event);
}